[![KendoReact NPM Banner](https://raw.githubusercontent.com/telerik/kendo-react/master/images/kendoreact-github-banner.png)](https://www.telerik.com/kendo-react-ui/components/free?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons&utm_content=banner)

# KendoReact Buttons Library for React

> **Important**
>
> -   This package is а part of [KendoReact](https://www.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)&mdash;an enterprise-grade UI library with 120+ free and premium components.
> -   It contains both free and premium KendoReact components and tools. To use the premium components, you will need to [purchase a license](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) or register for a [free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons). You can use the free components without having to sign up or get a license key.
> -   If you're looking for free React components, check out [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free).
> -   If you have an active license, visit the [KendoReact My License page](https://www.telerik.com/kendo-react-ui/components/my-license/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) to learn how to configure your KendoReact licensing.
> -   Installing and working with this package indicates that you [accept the KendoReact License Agreement](https://www.telerik.com/purchase/license-agreement/progress-kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons).
> -   The 30-day free trial gives you access to all KendoReact components and their full functionality. Additionally, for the period of your trial, you can use our legendary technical support provided directly by the KendoReact dev team!
>
> [Start using KendoReact](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) and speed up your development process!

The React Buttons package, part of KendoReact, includes a rich selection of fully configurable button types that help you create stylish and practical applications.

How to start:

```sh
npm i @progress/kendo-react-buttons
```

What's in this package:

-   [React Buttons Components Libray Features](#react-buttons-components-library-features)
-   [React Button component (free)](#react-button-component)
-   [React ButtonGroup component (free)](#react-buttongroup-component)
-   [React Chip component (free)](#react-chip-component)
-   [React ChipList component (free)](#react-chiplist-component)
-   [React DropDownButton component (premium)](#react-dropdownbutton-component)
-   [React FloatingActionButton component (free)](#react-floatingactionbutton-component)
-   [React SplitButton component (premium)](#react-splitbutton-component)
-   [React Toolbar component (free)](#react-toolbar-component)

Additional information:

-   [Support Options](#support-options)
-   [Resources](#resources)
-   [KendoReact Buttons API](https://www.telerik.com/kendo-react-ui/components/buttons/api)

## React Buttons Components Library Features

Here are some of the features shared across all components included in the package (this is not an exhaustive list):

-   **Disabled state**&mdash;To disable user interaction, just change a single property.
-   **Custom rendering**&mdash;You can replace the content of the buttons with custom icons, text and elements.
-   **Keyboard navigation**&mdash;You can interact with the buttons using only the keyboard.
-   **Accessibility support**&mdash;The Buttons are compliant with WAI-ARIA and Section 508.
-   [**Theme support**](https://www.telerik.com/kendo-react-ui/components/styling/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)&mdash;The KendoReact Buttons, as well as all 100+ components in the KendoReact suite, are styled in three polished themes (Bootstrap, Material, and Default) and can be further customized to match your specific design guidelines.

## React Button Component

> This is a **free React component**&mdash;no sign-up or license required.

[The React Button](https://www.telerik.com/kendo-react-ui/components/buttons/button/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) provides a clickable UI functionality and enables you to display only textual content, or show predefined icons, images and custom icons, and to render a combination of textual and image content.

Key features:

-   [Primary Button](https://www.telerik.com/kendo-react-ui/components/buttons/button/appearance#theme-colors)&mdash;As a part of several built-in styles for the KendoReact Button, the Primary Button provides a unique highlighted look and feel to the React Button component.
-   [Toggleable Button](https://www.telerik.com/kendo-react-ui/components/buttons/button/toggleable)&mdash;A KendoReact Button that can be toggled showcases a clear representation between the default rendering of the Button and when the Button has been pressed.
-   [Unstyled mode](https://www.telerik.com/kendo-react-ui/components/unstyled)&mdash;The KendoReact Button supports an unstyled mode, offering complete control over the Button appearance.

How to use the Button component in your apps:

```tsx
import { Button } from '@progress/kendo-react-buttons';
...
<Button>
    Button Label
</Button>
```

## React ButtonGroup Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact ButtonGroup](https://www.telerik.com/kendo-react-ui/components/buttons/buttongroup/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) is a container for two or more React Button components which can be separately configured to display only textual content, or show predefined icons, images and custom icons.

How to use the ButtonGroup component in your apps:

```tsx
import { Button, ButtonGroup } from '@progress/kendo-react-buttons';
...
<ButtonGroup>
    /**
    * Insert the <Button> components that you want to display as a group here.
    */
</ButtonGroup>
```

## React Chip Component

> This is a **free React component**&mdash;no sign-up or license required.

[The React Chip component](https://www.telerik.com/kendo-react-ui/components/buttons/chip/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) is responsible for a single Chip (also called React Pill) and can contain text, an image or avatar (optional) and a built-in icon, such as an "X," to indicate that an action can be taken.

Key features:

-   [Removable Chip](https://www.telerik.com/kendo-react-ui/components/buttons/chip/remove)&mdash;Through the removable property, React developers can configure whether the KendoReact Chip component should provide a built-in “X” icon to allow users to remove the Chip.
-   [Avatars and icons](https://www.telerik.com/kendo-react-ui/components/buttons/chip/appearance#chip-with-avatars)&mdash;The React Chip component lets you add avatars and font or SVG icons to create more compelling and user-friendly interfaces.
-   [Appearance](https://www.telerik.com/kendo-react-ui/components/buttons/chip/appearance)&mdash;The KendoReact Chip component provides the `size`, `fillMode`, `rounded`, and `themeColor` properties to let you control its look and feel.

How to use the Chip component in your apps:

```tsx
import { Chip } from '@progress/kendo-react-buttons';
...
<Chip
    text={'Chip Label'}
/>
```

## React ChipList Component

> This is a **free React component**&mdash;no sign-up or license required.

[The React ChipList component](https://www.telerik.com/kendo-react-ui/components/buttons/chiplist/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) takes the React Chip and provides additional functionality related to managing a collection of KendoReact Chip components.

Key features:

-   [Selection mode](https://www.telerik.com/kendo-react-ui/components/buttons/chiplist/selection-mode)&mdash;To ensure flexibility, the KendoReact ChipList component provides several selection modes.The default mode is “none”, which means no chips can be selected, yet you can enable single and multiple selection to help users manage their items individually or in bulk.
-   [Data Binding](https://www.telerik.com/kendo-react-ui/components/buttons/chiplist/data-binding)&mdash;As the KendoReact ChipList component deals with displaying and manipulating a collection of items, you can bind it to different data sources.

How to use the ChipList component in your apps:

```tsx
import { ChipList } from '@progress/kendo-react-buttons';
...
/**
* Introduce the data that you will use to populate the ChipList with chips.
*/
<ChipList
    data={data}
/>
```

## React DropDown Button Component

> This is a KendoReact **premium component** and requires a commercial license or an active trial license.

[The React DropDownButton component](https://www.telerik.com/kendo-react-ui/components/buttons/dropdownbutton/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) displays a popup list with action items and provides options for enabling or disabling its content, displaying icons, and binding it to data.

Key features:

-   [Icon DropDownButton](https://www.telerik.com/kendo-react-ui/components/buttons/dropdownbutton/icons)&mdash;The KendoReact DropDownButton can be displayed as just an icon or with a mix of text and icons as a part of its main content.
-   [Data Binding](https://www.telerik.com/kendo-react-ui/components/buttons/dropdownbutton/data-binding)&mdash;Beyond being declaratively built, the KendoReact DropDownButton component can be data bound to an array of strings or an array of objects.
-   [Unstyled mode](https://www.telerik.com/kendo-react-ui/components/unstyled)&mdash;The KendoReact DropDownButton supports an unstyled mode, offering complete control over its appearance.

How to use the DropDownButton with hardcoded data:

```tsx
import { DropDownButton, DropDownButtonItem } from '@progress/kendo-react-buttons';
...
<DropDownButton text="DropDownButton Label">
    <DropDownButtonItem text="Item 1 Label" />
    <DropDownButtonItem text="Item 2 Label" />
</DropDownButton>
```

How to use the DropDownButton with simple data binding:

```tsx
import { DropDownButton } from '@progress/kendo-react-buttons';
...
/**
* Provide an array of items for the drop-down here.
*/
<DropDownButton
    items={items}
    text="DropDownButton Label"
/>
```

## React FloatingActionButton Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact Floating Action Button](https://www.telerik.com/kendo-react-ui/components/buttons/floatingactionbutton/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) is a button that appears to “float” above the content of any React application, usually serving as a shortcut to a single, common action like adding an item or composing a new email.

Key features:

-   [Content Types](https://www.telerik.com/kendo-react-ui/components/buttons/floatingactionbutton/content-types)&mdash;The content within the KendoReact Floating Action Button can be completely customized through the available properties. Access the `icon`, `iconClass` and `text` properties to define the React Floating Action Button icon, apply a custom CSS class to control the style of the button, and set text displayed within the component.
-   [Speed Dial](https://www.telerik.com/kendo-react-ui/components/buttons/floatingactionbutton/speed-dial)&mdash;If additional action items should be available to users, the speed dial feature of the KendoReact Floating Action Button is the perfect solution.
-   [Positioning](https://www.telerik.com/kendo-react-ui/components/buttons/floatingactionbutton/positioning)&mdash;The KendoReact Floating Action Button provides several configuration options to assist with defining where the React component should be displayed within the application. The position can be set through easy-to-remember options like “start”, “center”, “end”, “top”, “middle” and “bottom”.

How to use a simple text FloatingActionButton component in your apps:

```tsx
import { FloatingActionButton } from '@progress/kendo-react-buttons';
...
<FloatingActionButton text={'FloatingActionButtonLabel'} />
```

## React SplitButton Component

> This is a KendoReact **premium component** and requires a commercial license or an active trial license.

[The KendoReact SplitButton component](https://www.telerik.com/kendo-react-ui/components/buttons/splitbutton/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) allows the user to execute a default action which is bound to a Button or to choose a predefined action from a drop-down list.

Key features:

-   [Icon SplitButton](https://www.telerik.com/kendo-react-ui/components/buttons/splitbutton/icons)&mdash;Each item within the KendoReact SplitButton can be rendered as just text, text along with an icon, or just as an icon.
-   [Data Binding](https://www.telerik.com/kendo-react-ui/components/buttons/splitbutton/data-binding)&mdash;The React SplitButton can be defined declaratively and can also be bound to an array of strings, or an array of objects.

How to use the SplitButtonComponent with hardcoded data:

```tsx
import { SplitButton, SplitButtonItem } from '@progress/kendo-react-buttons';
...
<SplitButton text="SplitButton Label">
    <SplitButtonItem text="Item 1 Label" />
    <SplitButtonItem text="Item 2 Label" />
</SplitButton>
```

How to use the DropDownButton with simple data binding:

```tsx
import { SplitButton } from '@progress/kendo-react-buttons';
...
/**
* Provide an array of items for the drop-down here.
*/
<SplitButton
    items={items}
    text="SplitButton Label"
/>
```

## React Toolbar Component

> This is a **free React component**&mdash;no sign-up or license required.

[The React Toolbar component](https://www.telerik.com/kendo-react-ui/components/buttons/toolbar/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) provides an intuitive component akin to the minimal toolbars found within traditional desktop applications like Word and Excel.

Key features:

-   [Tools](https://www.telerik.com/kendo-react-ui/components/buttons/toolbar/tools)&mdash;Within the KendoReact Toolbar, the Tools can be rendered as a Button, ButtonGroup, DropDownButton and SplitButtons. Of course, custom buttons can also be added.
-   [Globalization](https://www.telerik.com/kendo-react-ui/components/buttons/globalization)&mdash;The React Toolbar fully supports right-to-left (RTL) scenarios, ensuring that the component can be added in to any application, no matter what requirements for layout your applications have.

How to add a simple Toolbar component in your apps:

```tsx
import { Toolbar, Button, ButtonGroup } from '@progress/kendo-react-buttons'; // You need to install and import all KendoReact components that you want to render within your Toolbar.
...
<Toolbar>
    <ButtonGroup>
        <Button>Item 1</Button>
        <Button>Item 2</Button>
    </ButtonGroup>
</Toolbar>
```

## Support Options

For any issues you might encounter while working with the KendoReact Buttons, use any of the available support channels:

-   Industry-leading technical support&mdash;KendoReact paid license holders and users with an active (free) trial license can take advantage of our outstanding customer support. To submit a ticket, use [the dedicated KendoReact support system](https://www.telerik.com/account/support-center/contact-us/technical-support?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons).
-   Product forums&mdash;The [KendoReact forums](https://www.telerik.com/forums/kendo-ui-react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) are part of the free support you can get from the community and from the KendoReact team.
-   Feedback portal&mdash;The [KendoReact feedback portal](https://feedback.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons) is where you can request and vote for new features to be added.

## Resources

-   [Getting Started with KendoReact](https://www.telerik.com/kendo-react-ui/components/getting-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)
-   [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free)
-   [Getting Started with the KendoReact Buttons](https://www.telerik.com/kendo-react-ui/components/buttons/get-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)
-   [API Reference of the KendoReact Buttons](https://www.telerik.com/kendo-react-ui/components/buttons/api/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)
-   [KendoReact Roadmap](https://www.telerik.com/support/whats-new/kendo-react-ui/roadmap?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)
-   [Blogs](https://www.telerik.com/blogs/tag/kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)
-   [Demos, documentation, and component reference](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)
-   [KendoReact pricing and licensing](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)
-   [Changelog](https://www.telerik.com/kendo-react-ui/components/changelogs/ui-for-react/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-buttons)

High-level component overview pages

-   [React Button Component](https://www.telerik.com/kendo-react-ui/button)
-   [React ButtonGroup Component](https://www.telerik.com/kendo-react-ui/buttongroup)
-   [React Chip Component](https://www.telerik.com/kendo-react-ui/chip)
-   [React ChipList Component](https://www.telerik.com/kendo-react-ui/chiplist)
-   [React DropDownButton Component](https://www.telerik.com/kendo-react-ui/dropdownbutton)
-   [React Floating Action Button](https://www.telerik.com/kendo-react-ui/floatingactionbutton)
-   [React SplitButton Component](https://www.telerik.com/kendo-react-ui/splitbutton)
-   [React Toolbar Component](https://www.telerik.com/kendo-react-ui/toolbar)

_Copyright © 2025 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved._

_Progress, Telerik, and certain product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries._
